WISA.Forms.login = Ext.extend(WISA.Dialog, {
  /* Control references */ 
  blogin : null,
  eusername : null,
  epassword : null,
  plock : null,
  fform : null,
  /* Callbacks */
  loginbuttonclick : function (sender) {
    Application.DoLogin({user: this.eusername.getValue(), password: this.epassword.getValue() });
  },
  focususer : function () {
    this.eusername.focus();
  },
  /* Build the actual form */
  BuildForm: function (me) {
    this.eusername = new Ext.form.TextField({
      name:"user",
      fieldLabel:"Gebruikersnaam",
      inputType:"text"
    });
    this.epassword = new Ext.form.TextField({
      name:"pass",
      fieldLabel:"Wachtwoord",
      inputType:"password"
    });
    this.blogin = new Ext.Button({
       text:"Aanmelden",
       handler : this.loginbuttonclick,
       cls: 'wisa-aanmelden',
       scope : this
    });
    this.fform = new Ext.form.FormPanel({
      id : 'ffform-login', // DEVart add id
      width: 350,
      labelWidth:150,
      border:false,
      xtype: "form",
      buttonAlign: "right",
      bodyStyle: "padding: 10px 15px",
      defaultType: "textfield",
      defaults: {width: 150},
      items: [this.eusername,this.epassword],
      buttons:[this.blogin],
      keys: {key: Ext.EventObject.ENTER,  
             handler: function(){  
               this.blogin.focus(); 
               // DEVart : add login event to enter button
               Application.DoLogin({user: this.eusername.getValue(), password: this.epassword.getValue() });
               // DEVart : end
             }, 
             scope: this
      }
    });
    this.plock = new Ext.Panel({ 
      border:false,
      html:"<img src='pics/login.png' width=114 height=128/>",
      width:114,
      height:128
    });
    return {
      id   : 'wisa-login', 
      title: "Aanmelden",
      width: 500,
      height: 200,
      plain: true,
      layout: "hbox",
      headerCssClass: 'wisa-login',
      bodyCssClass: 'wisa-login',
      defaultButton: this.eusername,
      bodyCfg :{
        cls: 'x-panel-body'
      },
      layoutConfig: {
        align : "middle",
        pack: "center"
      },
      closable: false,
      listeners: {
        'show' : { fn: this.focususer.createDelegate(this) },
        'render' : { fn : function() { 
                new Ext.Panel({
                    id : 'wisa-login-logo',
                    border : false,
                    renderTo : Ext.getBody()
                });
            } 
        }
      },
      items: [ this.fform, this.plock ]  
    };
  }, /* Buildform*/
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      WISA.Forms.login.superclass.ApplyParams.call(this,Params);
      if ((Params.user) && (Params.password)) {
        this.eusername.setValue(Params.user);
        this.epassword.setValue(Params.password);
        this.loginbuttonclick();
      }
    }
  }
});

