WISA.Forms.mijnevaluatiefiches = Ext.extend(WISA.Form, {
  /* Control references */
  cm: null,
  sm: null,
  ficheid: -1,
  filters: null,
  border: false,
  bdetail: null,
  brefresh: null,
  fform : null,
  dsinstellingen : null,
  cbinstelling : null,
  isid : -1,
  periodeid : -1,
  isnaamgebruiker : '',
  gevaluatiefiches : null,
  dsevaluatiefiches : null,
  dsklassen : null,
  dsvakken : null,
  formdsperiodes : null,
  cbafgewerkt : null,
  cbperiode : null,
  fstarted : false,
  formatDate: function(date,p,record) {
    var s = '';
    s = date.dateFormat('d/m/Y');
    return s;
  },

  formatAfgewerkt: function(value, p, record) {
    if (record.json.DER_ID != null) {
      return "<img src='pics/check.png' width=16 height=16/>"
    }
  },

  GetEvaluatiefiches : function (gid,pid) {
    this.dsevaluatiefiches.load({params: {IS_ID: gid, P_ID: pid}});
  },

  GetKlassen : function (gid) {
    this.dsklassen.load({params: {IS_ID: gid}});
  },

  GetVakken : function (gid) {
    this.dsvakken.load({params: {IS_ID: gid}});
  },

  SelectInstelling : function(combo,record,index) {
    this.isid=this.cbinstelling.value;
    this.isnaamgebruiker=record.data.IS_NAAMGEBRUIKER;
    this.GetEvaluatiefiches(this.isid, this.periodeid);
    this.GetKlassen(this.isid);
    this.GetVakken(this.isid)
  },

  SelectPeriode : function(combo,record,index) {
    this.periodeid=record.data.P_ID;
    this.GetEvaluatiefiches(this.isid, this.periodeid);
  },

  AfgewerktClicked : function(checkbox,checked) {
    var colmodel=this.gevaluatiefiches.getColumnModel();
    if (this.cbafgewerkt.checked) {
      this.cbperiode.enable();
      colmodel.setHidden(colmodel.getIndexById('der_id'),false);
    }
    else {
      this.cbperiode.disable();
      colmodel.setHidden(colmodel.getIndexById('der_id'),true);
    }
  },

  HaveValidData : function(){
    if (! this.cbinstelling.isValid()) {
      WISA.ShowError('Geen instelling','Gelieve een instelling te selecteren');
    }
    else {
      var c = this.gevaluatiefiches.getSelectionModel().getSelections().length;
      if ( c == 0) {
        WISA.ShowError('Geen evaluatiefiche','Gelieve een evaluatiefiche te selecteren');
      }
      else {
        return true;
      }
    }
    return false;
  },

  IngaveStarted : function (Provider,Response) {
    this.started = false;
    this.bdetail.setDisabled(false);
    if (WISA.CheckError(Provider,Response,'Fout bij starten ingave: ')) {
      if (!Ext.isNumber(Response.result)) {
         WISA.ShowError('Fout op server','Server gaf geen correcte JobID terug');
      }
      else {
        Application.ShowForm( {form:'ingaveevaluatiefiche',Params: {JobID: Response.result, DEFID: this.ficheid,
          lastSelection: {instelling: this.isid, afgewerkt: this.cbafgewerkt.getValue(), periode: this.periodeid, defid: this.ficheid}}});
      }
    }
  },

  bdetailClicked : function(){
    if (this.fstarted) {
      WISA.ShowError('Gelieve te wachten tot het voorbereiden gedaan is')
    }
    else
    {
      if (this.HaveValidData()) {
        this.fstarted=true;
        this.bdetail.setDisabled(true);
        var sm = this.gevaluatiefiches.getSelectionModel();
        var sel = sm.getSelected();
        if (sm.hasSelection()) {
          if (this.HaveValidData()) {
            this.ficheid = sel.data.DEF_ID;
            TIngaveResultaat.StartIngave(this.ficheid,this.IngaveStarted.createDelegate(this));
          }
        }
      }
    }
  },

  InstellingLoaded : function (store,records, options) {
    if (records.length == 1) {
      this.cbinstelling.setValue(records[0].data.IS_ID);
      this.SelectInstelling(this.cbinstelling,records[0],0);
    } else if (!Ext.isEmpty(this.defaultSelection)) {
      var i = store.findExact('IS_ID',this.defaultSelection.instelling);
      if (i != -1) {
        this.cbinstelling.setValue(this.defaultSelection.instelling);
        this.SelectInstelling(this.cbinstelling,records[i],i);
      }
    }
  },

  PeriodeLoaded : function (store,records, options) {
    if (!Ext.isEmpty(this.defaultSelection)){
      if (!Ext.isEmpty(this.defaultSelection.afgewerkt)){
        if (!Ext.isEmpty(this.defaultSelection.periode)){
          var i = store.findExact('P_ID',this.defaultSelection.periode);
          if (i != -1) {
            this.cbperiode.setValue(this.defaultSelection.periode);
            this.SelectPeriode(this.cbperiode,records[i],i);
          }
        }
      }
    }
  },


  EvaluatieFichesLoaded : function (store,records,options) {
    if ( !Ext.isEmpty(this.defaultSelection)) {
      this.ficheid = this.defaultSelection.defid;
      var i=store.findExact('DEF_ID',this.ficheid);
      if (i != -1) {
        this.gevaluatiefiches.getSelectionModel().selectRow(i);
      }
    }
  },

  BuildForm: function () {
    this.dsinstellingen = new WISA.ClientDataset({
      ProviderName : 'WPSelectInstelling',
      autoLoad : true,
      listeners : { 'load': {fn: this.InstellingLoaded, scope : this}}
    });

    this.dsevaluatiefiches = new WISA.ClientDataset({
      ProviderName : 'WPSelectPersoneelEvaluatieFiche',
      autoload : false,
      listeners : { 'load': {fn: this.EvaluatieFichesLoaded, scope : this}}
    });

    this.dsklassen = new WISA.ClientDataset({
      ProviderName : 'WPFilterKlassen',
      autoload : false
    });

    this.dsvakken = new WISA.ClientDataset({
      ProviderName : 'WPFilterVakken',
      autoload : false
    });

    this.dsperiodes = new WISA.ClientDataset({
      ProviderName : 'WPSelectPeriodes',
      autoload : true,
      listeners : { 'load': {fn: this.PeriodeLoaded, scope : this}}
    });

    this.dsperiodes.load();

    this.cbinstelling = new Ext.form.ComboBox({
      allowBlank: false,
      store: this.dsinstellingen,
      fieldLabel: 'Instelling',
      dataField: 'IS_ID',
      valueField: 'IS_ID',
      displayField: 'IS_NAAMGEBRUIKER',
      width: 400,
      margin : '15 0 0 0', // DEVart added top margin
       padding : 10, // DEVart added padding
      triggerAction:'all',
      lazyInit: false,
      forceSelection: true,
      mode: 'local',
      valueNotFoundText : 'Waarde niet gevonden',
      listeners : {
        'select': {
          fn: this.SelectInstelling,
          scope: this
        }
      }
    });

    this.cbafgewerkt = new Ext.form.Checkbox ({
      fieldLabel: 'Afgewerkt',
      listeners : {
        'check': {
          fn: this.AfgewerktClicked,
          scope: this
        }
      }
    });

    this.cbperiode = new Ext.form.ComboBox({
      store: this.dsperiodes,
      fieldLabel: '',
      dataField: 'P_ID',
      valueField: 'P_ID',
      displayField: 'P_OMSCHRIJVING',
      width: 400,
      triggerAction:'all',
      lazyInit: false,
      forceSelection: true,
      mode: 'local',
      valueNotFoundText : 'Waarde niet gevonden',
      editable: false,
      emptyText: '',
      enableKeyEvents: true,
      listeners : {
        'select': {
          fn: this.SelectPeriode,
          scope: this
        }
      }
    });

    this.cbperiode.disable();
    this.filters = new Ext.ux.grid.GridFilters({
      local: true,
      filters: [
        {type: 'list', dataIndex: 'IV_NAAMGEBRUIKER', store: this.dsvakken, phpMode: false},
        {type: 'list', dataIndex: 'KL_CODE', store: this.dsklassen, phpMode: false}
      ]//, DEVart removed this 
    }),

    this.cm = new Ext.grid.ColumnModel({
      defaults: {
        width: 150,
        sortable: true
      },
      columns: [
        {id:'der_id',dataIndex: 'DER_ID', header: 'Afgewerkt', renderer: this.formatAfgewerkt, hidden: true, width: 60, align: 'center'},
        {dataIndex: 'LL_NAAM', header: 'Naam', width: 150},
        {dataIndex: 'LL_VOORNAAM', header: 'Voornaam', width: 150},
        {dataIndex: 'LL_GEBOORTEDATUM', header: 'Geboortedatum', renderer: this.formatDate, width: 100},
        {dataIndex: 'IU_STAMBOEKNUMMER', header: 'Stamboeknummer', width: 100},
        {dataIndex: 'IV_NAAMGEBRUIKER', header: 'Ingericht vak', width: 150},
        {dataIndex: 'AG_OMSCHRIJVING', header: 'Administratieve groep', width: 150},
        {dataIndex: 'DKOOPTIE_OMSCHRIJVING', header: 'Optie', width: 80},
        {dataIndex: 'DKOGRAAD_EXTRA', header: 'Graad', width: 50},
        {dataIndex: 'DKOLEERJAAR_CODE', header: 'Leerjaar', width: 50},
        {dataIndex: 'KL_CODE', header: 'Klas', width: 80}
/*        {dataIndex: 'DEF_ID', hidden: true, header: 'ID Evaluatiefiche'},
        {dataIndex: 'LL_ID', hidden: true, header: 'ID Leerling'},
        {dataIndex: 'IU_ID', hidden: true, header: 'ID Inuit'},
        {dataIndex: 'IV_ID', hidden: true, header: 'ID Ing. vak'},
        {dataIndex: 'AG_ID', hidden: true, header: 'ID Adm. groep'},
        {dataIndex: 'DKOOPTIE_ID', hidden: true, header: 'ID Optie'},
        {dataIndex: 'DKOGRAAD_ID', hidden: true, header: 'ID Graad'},
        {dataIndex: 'DKOLEERJAAR_ID', hidden: true, header: 'ID Leerjaar'},
        {dataIndex: 'KL_ID', hidden: true, header: 'ID Klas'}*/
      ]
    }),

    this.sm = new Ext.grid.RowSelectionModel({singleSelect: true}),

    this.gevaluatiefiches = new Ext.grid.GridPanel({
      store: this.dsevaluatiefiches,
      plugins: this.filters,
      cm: this.cm,
      sm: this.sm,
      frame: true,
      height: 380,
      autoScroll: true,
      title: 'Mijn evaluatiefiches',
      iconCls: 'mijnevaluatiefiches'//, DEVart removed this
//      stateful: true,
//      stateId: 'gevaluatiefiches'
    });

    this.gevaluatiefiches.on({
      'rowdblclick' : this.bdetailClicked,
      scope: this
    });

    this.bdetail = new Ext.Button({
      id : 'btnDetailEvaluatieFiche',
      cls : 'wisa-btn', 
      height : 24, // DEVart added height
      text: 'Detail evaluatiefiche',
      iconCls: 'detailevaluatiefiche',
      handler: this.bdetailClicked,
      scope: this
    });

    this.fform = new Ext.FormPanel({
      labelSeparator: ' ',
      region: 'center',
      border: false, // DEVart removed border
      buttonAlign: 'left',
      title: 'Filter',
      padding : 10, // DEVart added padding
      //items: [this.cbinstelling, this.cbafgewerkt, this.cbperiode, this.gevaluatiefiches], DEVart changed content
      items: [this.cbinstelling, this.cbafgewerkt, this.cbperiode],
      //buttons: [this.bdetail], // DEVart: Moved buttons to container
      autoScroll: true,
      iconCls: 'funnel'
    });

    return { layout: "vbox", border: false, autoScroll: true, layoutConfig: {align: 'stretch', pack: 'top', padding: '10 0 0 0'}, items: [this.fform, this.gevaluatiefiches], buttons: [this.bdetail] };
//    return { layout: "auto", autoScroll: true, items: [this.fform] };

  },

  getFormTitle: function () {
    return 'Mijn evaluatiefiches';
  },

  ApplyDefaultSelection: function() {
    this.cbafgewerkt.setValue(this.defaultSelection.afgewerkt);
  },

  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      // Call inherited ApplyParams
      WISA.Forms.login.superclass.ApplyParams.call(this, Params);
      if (! Ext.isEmpty(Params.defaultSelection)) {
        this.defaultSelection = Params.defaultSelection;
        this.ApplyDefaultSelection();
      }
    }
  }
});
