WISA.Forms.changepassword = Ext.extend(WISA.Dialog, {
  eold : null,
  enew : null,
  enewcheck : null,
  bchange : null,
  bcancel : null,
  PasswordChanged : function (Provider,Response) {
    if ( Ext.isEmpty(Response) || (! Ext.isEmpty(Response.error))) {
      WISA.AjaxError('Fout bij wijzigen wachtwoord: '+Response.error.message);
    } else {
      this.close();
    }
  },
  ChangeClick : function () {
    if (this.enew.getValue() != this.enewcheck.getValue()) {
      WISA.ShowError('Wachtwoord wijziging mislukt','De nieuwe wachtwoorden zijn niet hetzelfde. Probeer opnieuw.');
    } else {
      WisaUserAPI.ChangePassword(this.eold.getValue(),this.enew.getValue(), this.PasswordChanged.createDelegate(this));
    }
  },
  CancelClick : function () {
    this.close();
  },
  BuildForm: function (me) {
    this.eold = new Ext.form.TextField({
      name:"oldpw",
      fieldLabel:"Huidig wachtwoord",
      inputType:"password"
    });
    this.enew = new Ext.form.TextField({
      name:"newpd",
      fieldLabel:"Nieuw wachtwoord",
      inputType:"password"
    });
    this.enewcheck = new Ext.form.TextField({
      name:"newpdcheck",
      fieldLabel:"Herhaal nieuw wachtwoord",
      inputType:"password"
    });
    this.bchange = new Ext.Button({
       text:"Wijzigen",
       handler : this.ChangeClick,
       cls: 'wisa-wijzigwachtwoord',
       scope : this
    });
    this.bcancel = new Ext.Button({
       text:"Annuleren",
       handler : this.CancelClick,
       cls: 'wisa-wijzigwachtwoord',
       scope : this
    });
    this.fform = new Ext.form.FormPanel({
      labelWidth:200,
      border:false,
      xtype: "form",
      buttonAlign: "right",
      bodyStyle: "padding: 10px 15px", 
      defaultType: "textfield",
      defaults: {width: 150},
      items: [this.eold,this.enew,this.enewcheck],
      buttons:[this.bchange, this.bcancel]
    });
    return {
      title: "Wachtwoord wijzigen",
      width: 500,
      height: 250,
      plain: true,
      layout: "hbox",
      /*headerCssClass: 'wisa-wijzigwachtwoord',
      bodyCssClass: 'wisa-wijzigwachtwoord',*/
      bodyCfg :{
        cls: 'x-panel-body'
      },
      layoutConfig: {
        align : "middle",
        pack: "center"
      },
      closable: true,
      items: [ this.fform ]
    };
  }
});

WISA.Forms.myprofile = Ext.extend(WISA.Form, {
  fform : null,
  dsuser : null,
  bchangepwd : null,
  LoadData: function (store,records,options) {
    if (records.length==1) {
      this.fform.getForm().loadRecord(records[0]);
      this.bchangepwd.setDisabled(records[0].data.U_KANVERANDERPASW!='+');
    }
  },
  ChangePassword : function () {
    Application.ShowDialog({form: 'changepassword'});
  } ,
  BuildForm: function () {
    this.dsuser = new WISA.ClientDataset({
      ProviderName: 'UserFiche',
      listeners: {load: {fn: this.LoadData, scope : this}},
      autoLoad: true
    });
    this.bchangepwd = new Ext.Button({
      id  : 'wisa-wijzigwachtwoord', // DEVart: added id  
      text: 'Wachtwoord wijzigen',
      enabled: false,
      handler: this.ChangePassword
    });
    this.fform = new Ext.form.FormPanel({
      title : 'Gebruikersgegevens',
      labelWidth : 200,
      padding : 10, // DEVart added padding
      cls: 'wisa-sub-panel',
      border: false, 
      items : [
       {name: 'U_ID', /* disabled: true, */ fieldLabel: 'Gebruikersnummer', xtype: 'textfield'},
       {name: 'U_NAAM', /* disabled: true, */ fieldLabel: 'Gebruikersnaam', xtype: 'textfield'},
       {name: 'U_NAAMVOLLEDIG',  /* disabled: true, */  fieldLabel: 'Volledige naam', xtype: 'textfield'},
       {name: 'U_LAATSTELOGIN',  /* disabled: true, */ fieldLabel: 'Laatst aangemeld op', xtype: 'datefield', format : 'd/m/Y' },
       {name: 'U_LAATSTELOGOUT',  /* disabled: true, */ fieldLabel: 'Laatst afgemeld op', xtype: 'datefield', format : 'd/m/Y' },
       {name: 'U_VRIJVELD1',  /* disabled: true, */ fieldLabel: 'Vrij veld 1', xtype: 'textfield' },
       {name: 'U_VRIJVELD2',  /* disabled: true, */ fieldLabel: 'Vrij veld 2', xtype: 'textfield' }
      ],
      buttons: [ this.bchangepwd ]
    });
    return { layout: 'vbox',layoutConfig: {align: 'stretch', pack: 'top', padding: '10 50 10 10'}, items : [ this.fform] }
  },
  getFormTitle: function () {
    return "Mijn gebruikersgegevens";
  },
  ApplyParams : function (Params) {
  //
  }
});
