Ext.ns('Ext.ux.grid');
Ext.ux.grid.SelectionColumn = Ext.extend(Object, {
    init: function(grid) {
        this.columns = [];
        grid.on('cellclick', this.onCellClick, this);
        grid.on('destroy', this.onDestroy, this, {single: true});
    },
    onCellClick: function(grid, rowIndex, colIndex, e) {
        var t = e.getTarget();
        if (t && Ext.fly(t).hasClass('ux-sc-item')) {
            var record = grid.getStore().getAt(rowIndex),
                col = grid.getColumnModel().getColumnAt(colIndex),
                i = 0;
            while (t = t.previousSibling) {
                i++;
            }
            record.set(col.dataIndex, col.values[i]);
        }
    },
    onDestroy: function(grid) {
        grid.un('cellclick', this.onCellClick, this);
    },
    createColumn: function(config) {
        return new Ext.grid.Column(Ext.apply({
            renderer: this.renderer.createDelegate(this, [config], 0)
        }, config));
    },
    renderer: function(config, value, meta) {
        meta.css += 'ux-sc-column';
        var s = [];
        for (var i = 0; i < config.values.length; i++) {
            var cvalue = config.values[i],
                ctext = config.displayValues ? config.displayValues[i] : cvalue,
                cwidth = (Ext.isArray(config.valueWidth) ? config.valueWidth[i] : config.valueWidth) || 12;
            s.push(
                '<div class="ux-sc-item',
                value == cvalue ? ' ux-sc-selected' : '',
                '" style="width: ',
                cwidth,
                'px">',
                ctext,
                '</div>'
            );
        }
        return s.join('');
    }
});
